##
## Picon renderer by Gruffy
##
from Renderer import Renderer
from enigma import ePixmap
from Tools.Directories import SCOPE_SKIN_IMAGE, resolveFilename
from Tools.Directories import fileExists
import os
from os import listdir
# --> 1/2 Anfang
from Components.config import config, ConfigSubsection, ConfigEnableDisable, getConfigListEntry, ConfigSelection, NoSave, ConfigNothing

config.misc.picon = ConfigSelection(default = "hdd", choices = [("hdd", _("/hdd/picon")), ("cf", _("/cf/picon")), ("usb", _("/usb/picon"))])
# <-- 1/2 Ende

class Picon(Renderer):
	def __init__(self):
		Renderer.__init__(self)
		# --> 2/2 Anfang
		#self.searchPaths = [	'/etc/picon/', 
		#			'/media/cf/picon/',
		#			'/media/usb/picon/']
		if config.misc.picon.value == "cf":
			self.searchPaths = [	'/etc/picon/',
						'/media/cf/picon/']
		elif config.misc.picon.value == "usb":
			self.searchPaths = [	'/etc/picon/',
						'/media/usb/picon/']
		elif config.misc.picon.value == "hdd":
			self.searchPaths = [	'/etc/picon/',
						'/media/hdd/picon/']
		# <-- 2/2 Ende
	GUI_WIDGET = ePixmap

	def changed(self, what):
		try:
			if what[0] == self.CHANGED_CLEAR:
				pngname = self.findPicon("picon_default")
			else:
				pngname = self.findPicon(self.source.text)
				if pngname == "":
					pngname = self.findPicon("picon_default")
				self.instance.setPixmapFromFile(pngname)
		except:
			print "Sorry...but Picon failed..."	
	
	def findPicon(self, serviceName):
		for path in self.searchPaths:
			png = self.findFile(path, serviceName)
			if png != "":
				return png
			
		return ""
	

	def findFile(self, path, serviceName):
		pngname = path + serviceName + ".png"
		if fileExists(pngname):
			return pngname
		else:
			for i in range(len(serviceName), 1, -1):
				if fileExists(path + serviceName[0:i] + ".png"):
					return path + serviceName[0:i] + ".png"
			return ""
		
			
			
			